/*
   Quick Delete Tree 1.7
   compile it under huge mode , Turbo C++ 1.0
*/
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>
#include <alloc.h>
#include <string.h>
#include <dir.h>
#include <ctype.h>

typedef unsigned char byte;
typedef unsigned int word;
typedef unsigned long dword;
typedef struct dpbbuf {
    byte physdrive;
	byte driveunit;
	word bytessector;
	byte sectorscluster;
	byte clustershift;
	word reserve;
	byte numberoffats;
	word direntries;
	word datasect;
	word totclust;
	word nfatsec;
	word dirsect;
	} dpb;
typedef struct dirbuf {
	char name[11];
	byte attrib;
	byte reserved[10];
	word time;
	word date;
	word clust;
	dword size;
	} dir;
union {
	struct {
		char	f_reserved[13];
		word	f_count;
		word	f_clust;
		char	f_reserved2[4];
		char      f_attrib;
		unsigned  f_ftime;
		unsigned  f_fdate;
		long      f_fsize;
		char      f_name[13];
	} f;
	struct ffblk ffblk;
} fblk;

union {word huge *w;
	byte huge *b;
	} fatbuf;
word seg;
word huge *nextseg;
byte dnum;
dpb far *dpbptr;
word clunit;
word bytclust;
dword fatsize;
dword totsect;
word end;
char save[80];
dir near * dirbuf,near * rootbuf,huge *readptr,near *dirend;
void (*diskaccess)(byte fun,dword start,word count,byte huge *buf);
word (*nextclust)(word clust);
void (*clearclust)(word clust);

#define QSIZE	4096
#define cl2sec(cl)	((dword)dpbptr->datasect+((dword)(cl)-2)*clunit)
#define abs_read(s,c,b) diskaccess(0x25,(dword)(s),(word)(c),(b))
#define abs_write(s,c,b)	diskaccess(0x26,(dword)(s),(word)(c),(b))
//#define abs_write(s,c,b) 0
#define readclust(cl)	abs_read(cl2sec(cl),clunit,readptr)
#define writeclust(cl)	abs_write(cl2sec(cl),clunit,readptr)

dpb far *getdpb(void);
void diskaccess16(byte fun,dword start,word count,byte huge *buf);
void diskaccess32(byte fun,dword start,word count,byte huge *buf);
word nextclust12(word clust);
word nextclust16(word clust);
void clearclust12(word clust);
void clearclust16(word clust);
void setfat(word clust);
void deltree(word clust);

void setfat(word clust)
{
	word c;
	while ((c=nextclust(clust))<end && c>1)
	{
		clearclust(clust);
		clust=c;
	}
	clearclust(clust);
}

dpb far *getdpb(void)
{
	union REGS inregs,outregs;
	struct SREGS segregs;
	inregs.h.ah=0x32;
	inregs.h.dl=0;
	intdosx(&inregs,&outregs,&segregs);
	if (outregs.x.cflag) {
		printf("Can't read drive %c Paramters.\n",(dnum+'A'));
		exit (1);
		}
	return ((dpb far *)MK_FP(segregs.ds,outregs.x.bx));
}

void clearclust12(word clust)
{
	dword c;
	c=(dword)clust*3/2;
	if (clust & 1) fatbuf.b[c]&=0xf,fatbuf.b[c+1]=0;
	else fatbuf.b[c]=0,fatbuf.b[c+1]&=0xf0;
}

void clearclust16(word clust)
{
	if (clust>>15) nextseg[clust&0x7fff]=0;
	else fatbuf.w[clust]=0;
}

word nextclust12(word clust)
{
	word next;
	next=*(word huge *)(fatbuf.b+(dword)clust*3/2);
	if (clust & 1) next>>=4;
	else next &=0x0fff;
	return next;
}

word nextclust16(word clust)
{
	if (clust>>15) return(nextseg[clust&0x7fff]);
	else return (fatbuf.w[clust]);
}

void diskaccess16(byte fun,dword start,word count,byte huge *buf)
{
	union REGS inregs,outregs;
	struct SREGS segregs;
	inregs.h.al=dpbptr->physdrive;
	inregs.x.dx=(word)start;
	inregs.x.cx=count;
	inregs.x.bx=FP_OFF(buf);
	segregs.ds=FP_SEG(buf);
	int86x(fun,&inregs,&outregs,&segregs);
	if (outregs.x.cflag) {
		printf("DISK ERROR.\n");
		exit (1);
		}
}

void diskaccess32(byte fun,dword start,word count,byte huge *buf)
{
	union REGS inregs,outregs;
	struct SREGS segregs;
	typedef struct { dword sec;
		word count;
		byte huge *buf;
		} dlist;
	dlist list;
	list.sec=start;
	list.count=count;
	list.buf=buf;
	inregs.h.al=dpbptr->physdrive;
	inregs.x.cx=-1;
	inregs.x.bx=FP_OFF((dlist far *)&list);
	segregs.ds=FP_SEG((dlist far *)&list);
	int86x(fun,&inregs,&outregs,&segregs);
	if (outregs.x.cflag) {
		printf("%ld",(start-(dword)dpbptr->datasect)/clunit+2);
		printf("DISK ERROR.\n");
		exit (1);
		}
}

word queue[QSIZE];

void deltree(word clust)
{
	dir near *dirptr;
	word head=0,tail=1,c;
	readptr=dirbuf;
	queue[0]=clust;
	while(head!=tail) {
		c=clust=queue[head];
		head=(head+1)%QSIZE;
		dirptr=dirbuf;
		readclust(clust);
		while (dirptr[1].name[0]!='\0')
		{
			if (dirptr++>=dirend) {
				clust=nextclust(clust);
				dirptr=dirbuf;
				readclust(clust);
				}
			 if (dirptr->name[0]!='\xe5' && dirptr->name[0]!='.')
				if ((dirptr->attrib & FA_DIREC) ==0) setfat(dirptr->clust);
				else { queue[tail]=dirptr->clust;
					   if ((tail=(tail+1)%QSIZE)==head) {
					printf("Queue is full.\n");
					exit(1);
					}
				       }
		}
		setfat(c);
		}
		readptr=rootbuf;
}

int main(int argc,char *argv[])
{
	int secp64,i;
	word s,s1=0xffff,clust,clust1=0xffff,num,count;
	word mnum;
	int done,p=1,del=0;
	char pp='Y';
	char command[80],c2[80],*chptr,*chptr2;
	if (argc<2 || argv[1][0]=='/') {
		printf("Quick Delete Tree v1.7 , Sep 29 1997\n");
		printf("Written by Wu Yun-yang.\n");
		printf("This is PD,Please Copy!!\n\n");
		printf("Usage:\tQDT [d:][path]dirname [/Y]\n");
		printf("\tQDT . [/Y]\t(Delete curdir).\n");
		printf("e.g.\tQDT *.*\n");
		printf("QDT can also delete files.\n");
		return 1;
		}
	strcpy(command,argv[1]);
	if ((chptr=strchr(command,'/'))!=NULL) {strcpy(c2,chptr);*chptr='\0';}
	else strcpy(c2,argv[2]);
	strupr(c2);
	if (strcmp(c2,"/Y")==0) p=0;
	chptr2=command;
	dnum=getdisk();
	strupr(command);
	getcurdir(0,save);
	if (chptr2[1]==':') {setdisk(command[0]-'A');chptr2+=2;}
	if (strcmp(chptr2,".")==0)
		if (save[0]=='\0') strcpy(command,"*.*");
		else { strcpy(command,save);
			chdir("..");
			getcurdir(0,save);
		}
	if (chptr2[0]=='\\') {
		chdir("\\");
		chptr2++;
		}
	chptr=chptr2;
	while((chptr=strchr(chptr2,'\\'))!=0) {
		*chptr='\0';
		chdir(chptr2);
		chptr2=chptr+1;
		}
	if (chptr2[0]=='\0') strcpy(command,"*.*");
	else strcpy (command,chptr2);
	dpbptr=getdpb();
	fatsize=(dword)dpbptr->bytessector*dpbptr->nfatsec;
	clunit=dpbptr->sectorscluster+1;
	totsect=(dword)dpbptr->totclust*clunit+(dword)dpbptr->datasect;
	bytclust=dpbptr->bytessector*clunit;
	dirbuf=(dir near*)malloc(bytclust);
	rootbuf=(dir near*)malloc(bytclust);
	if (allocmem((fatsize>>4)+1,&seg)!=-1 || dirbuf==NULL || rootbuf==NULL) {
		printf("Mem alloc error\n");
		exit(1);
	}
	fatbuf.w=(word huge*)MK_FP(seg,0);
	nextseg=(word huge*)MK_FP(seg+0x1000,0);
	if (dpbptr->totclust>0xfef) nextclust=nextclust16,clearclust=clearclust16,end=0xfff0;
	else nextclust=nextclust12,clearclust=clearclust12,end=0xff0;
	if (totsect>>16) diskaccess=diskaccess32;
	else diskaccess=diskaccess16;
	secp64=0x10000L/dpbptr->bytessector;
	if (0x10000L%dpbptr->bytessector) {
		printf("Sorry, QDT can't work at drive with %d Byte per sector.\n");
		exit (1);
		}
	if (fatsize>>16) {
		abs_read(dpbptr->reserve,secp64,fatbuf.b);
		abs_read(dpbptr->reserve+secp64,dpbptr->nfatsec-secp64,nextseg);
		}
	else abs_read(dpbptr->reserve,dpbptr->nfatsec,fatbuf.b);
	mnum=fatbuf.w[0];
	done=findfirst(command,&fblk.ffblk,0xff);
	dirend=(dir near *)((word)dirbuf+bytclust-1);
	readptr=rootbuf;
	if (fblk.f.f_clust<2) num=dpbptr->bytessector/sizeof(dir);
	else num=bytclust/sizeof(dir);
	while (!done)
	{
		if (fblk.f.f_name[0]=='.') goto LOOP;
		clust=fblk.f.f_clust,count=fblk.f.f_count;
		if (fblk.f.f_clust<2) {
			s=dpbptr->numberoffats*dpbptr->nfatsec+dpbptr->reserve;
			s+=count/num;
			count%=num;
			if (s1==0xffff) abs_read(s1=s,1,readptr);
			else if (s!=s1) { abs_write(s1,1,readptr);
				abs_read(s1=s,1,readptr);
				}
		}
		else {
			s=count/num;
			for (i=0;i<s;i++) clust=nextclust(clust);
			count%=num;
			if (clust1==0xffff) readclust(clust1=clust);
			else if (clust1!=clust) {
					writeclust(clust);
					readclust(clust1=clust);
					}
			}
		if (fblk.ffblk.ff_attrib & FA_DIREC) {
			if (p) {
				printf("Delete %s <DIR> ? ",fblk.f.f_name);
				pp=getche();printf("\n");
				if (pp==27) goto LOOP2;
				if (pp>='a') pp-=('a'-'A');
				}
			if (pp=='Y') {del=1;deltree(rootbuf[count].clust);}
			}
		else {
			if (p) { printf("Delete %s ? ",fblk.f.f_name);
				pp=getche();printf("\n");
				if (pp==27) goto LOOP2;
				if (pp>='a') pp-=('a'-'A');
				}
			if (pp=='Y') {del=1;setfat(rootbuf[count].clust);}
		}
		if (pp=='Y') rootbuf[count].name[0]='\xe5';
LOOP:		done = findnext(&fblk.ffblk);
	}
LOOP2:if (del) {
   if (clust<2) abs_write(s,1,readptr);
   else writeclust(clust);
   fatbuf.w[0]=mnum;
   for (i=0;i<dpbptr->numberoffats;i++)
	  if (fatsize>>16) {
	abs_write(dpbptr->reserve+i*dpbptr->nfatsec,secp64,fatbuf.b);
	abs_write(dpbptr->reserve+i*dpbptr->nfatsec+secp64,dpbptr->nfatsec-secp64,nextseg);
	}
	else  abs_write(dpbptr->reserve+i*dpbptr->nfatsec,dpbptr->nfatsec,fatbuf.b);
	}
  /*
	{
	dword l;
	int aaa;
	FILE *f;
	f=fopen("c:\\a.fat","wb");
	for (l=0;l<fatsize;l++) {
		aaa=fatbuf.b[l];
		fputc(aaa,f);
		}
	fclose(f);
	abs_read(dpbptr->reserve,secp64,fatbuf.b);
	if (fatsize>>16)
		abs_read(dpbptr->reserve+secp64,dpbptr->nfatsec-secp64,nextseg);
	f=fopen("c:\\b.fat","wb");
	for (l=0;l<fatsize;l++) {
		aaa=fatbuf.b[l];
		fputc(aaa,f);
		}
	}
	*/
   /*
   free(rootbuf);
   free(dirbuf);
   farfree(farptr);
   */
   setdisk(dnum);
   chdir(save);
   return 0;
}

